/*************-//| 7a69Soft - http://www.7a69ezine.8m.com |\\-*************** 
*                                                                           *
*  TILE: DNI v0.1                                                           *
*  CODER: Trycky - < trycky_83@mixmail.com >                                *  
*                                                                           *
*  TO COMPILE: ./Compilar                                                   *
*                                                                           * 
*  NOTE: Programa que muestra la NIF del carned de identidad.               *
*                                                                           *
*        Haziendolo de la siguiente forma.                                  *
*         								    *
*        Se divide el numero entre 23 :                                     *
*        12 667 183 / 23 : 550747                                           *
*                                                                           *
*        Se le quita los decimales y se multiplica por 23 :                 * 
*        550747 * 23 : 12667181                                             *
*                                                                           *
*        Restamos el DNI con el numero resultante que es 12667181 :         *
*        12667183 - 12667181 : 2 --> la letra W                             *
*                                                                           * 
*        El resultado sera un numero entre el 0 y el 23 se compara con esta *
*        tabla y ya esta:                                                   *
*                                                                           *
*        0 - T   4 - G   8 - P   12 - N   16 - Q    20 - C                  *
*        1 - R   5 - M   9 - D   13 - J   17 - V    21 - K                  *
*        2 - W   6 - Y  10 - X   14 - Z   18 - H    22 - E                  * 
*        3 - A   7 - F  11 - B   15 - S   19 - L    23 - T                  *
*                                                                           *
*        La forma de averiguar el DNI no es mia ahora no recuerdo           *
*        exanctamente donde la lei pero me parecio intresante, y ademas, asi* 
*        se va aprendiendo a programar.                                     *
*                                                                           *
*        Bajo licencia de conducir A . Broma absurda despues de haber jugado* 
*        medio dia al Gran turismo 2. Este programa podeis cambiarlo,       *
*        distribuirlo, etc. Total no creo que pierda nada. GNU              *
*                                                                           *
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>

#define AZUL   "\033[00;36m"
#define STAN   "\033[00;00m"
#define BLANCO "\033[00;04m"
#define BRILLA "\033[00;05m"

#define SALIDA "dni.txt"
#define VERSION "Version 0.1 By Trycky . Generador de NIF"

void numero_amano();
void generar_nif();
void letra();
void nif_aleatorio();
void aborta();
void salida();
void leo_dni();

 int NUM=23,DNI,CALCULO,CALCULO2,LETRA;
 int ELEC;
 int NUM_ALEA;
 char KEYY;
 char arch_dni[12];
 int a;
 int NUM_ALEA,kk; 
 int guardo_auto=0; // 0 Desactivado , 1 Activado
 char *activo="DESACTIVADO";

main()
{
   signal (SIGINT, aborta);

   if ((a=fopen(SALIDA,"w+")) == NULL){
   printf("\n Error al crear el fichero %s. \n",SALIDA);
   exit(-1);
    }
  
    if (guardo_auto==1)
       activo="ACTIVADO"; 
    else
      activo="DESACTIVADO";
     
    do{
    system("clear");
    printf("%s\n \n",VERSION);
    printf(BLANCO"\n1 )=-> Generar tabla de DNI aleatorios:");
    printf(BLANCO"\n2 )=-> Meter DNI para averiguar el Nif:");
    printf(BLANCO"\n3 )=-> Guardar automaticamente. (%s) en (%d)",activo,guardo_auto);
    printf(BLANCO"\n4 )=-> Leer archivo con tabla de DNI:");
    printf(BLANCO"\n5 )=-> Salir.\n\n"STAN"");
    printf(AZUL"Elige la opcion: "STAN"");
    scanf("%d",&ELEC);
    switch(ELEC)
     {
    case 1: nif_aleatorio(); break;
    case 2: numero_amano(); break; 
    case 3: if (guardo_auto==1)
    guardo_auto=0;
    else
    guardo_auto=1;
    main(); break;
    case 4: leo_dni(); break;
    case 5: salida(); break; 
     }
    }while(ELEC!='5');   

  fclose(a);
 
}

void numero_amano()
{
printf(BLANCO"\nEscribe el numero del DNI : "STAN"");
scanf("%d",&DNI);

 if (DNI<=10000000 | DNI>=99999999){
  system("clear");
  printf(BRILLA"Tienes que escribir los 9 digitos del carnet \n"STAN"");
  numero_amano(); }

   else
generar_nif();    
}

void generar_nif()
{
  
    CALCULO=DNI/NUM;
    CALCULO2=CALCULO*NUM;
    LETRA=DNI-CALCULO2;   

 printf("\n1 Calculo (DNI/23) : %i \n\n",DNI/NUM);
 printf("2 Calculo (Calculo*23) : %i \n\n",CALCULO*NUM);
 printf("3 Calculo (DNI-Calculo) : %i \n\n",DNI-CALCULO2);
 
 letra();

if(guardo_auto==0)

printf(STAN"Guardar Salida (S/N) : ");
 scanf("%s",&KEYY);
 switch(KEYY) {
 case 's':
 case 'S':
 printf("\nGuardado en %s \n",SALIDA);
 fprintf(a,"Guardado a %s a las %s \n",__DATE__ , __TIME__);
 exit (0);
 break;
 case 'n':
 case 'N':
 printf("No Guardado.\n%s\n",VERSION);
 main();
 break; 
}

 // printf(AZUL"\n%s \n\n"STAN"",VERSION);
  return(0);
}

void letra()
{
 switch(LETRA)
     {
 case 0: printf(BLANCO"La letra es la T del DNI %d \n\n"STAN"",DNI);  
         fprintf(a,"La letra es la T del DNI %d \n\n",DNI); break;
 case 1: printf(BLANCO"La letra es la R del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la R del DNI %d \n\n",DNI); break;
 case 2: printf(BLANCO"La letra es la W del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la W del DNI %d \n\n",DNI); break;
 case 3: printf(BLANCO"La letra es la A del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la A del DNI %d \n\n",DNI); break;
 case 4: printf(BLANCO"La letra es la G del DNI %d \n\n"STAN"",DNI);
         fprintf(a,"La letra es la G del DNI %d \n\n",DNI); break;
 case 5: printf(BLANCO"La letra es la M del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la M del DNI %d \n\n",DNI); break;
 case 6: printf(BLANCO"La letra es la Y del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la Y del DNI %d \n\n",DNI); break;
 case 7: printf(BLANCO"La letra es la F del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la F del DNI %d \n\n",DNI); break;
 case 8: printf(BLANCO"La letra es la P del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la P del DNI %d \n\n",DNI); break;
 case 9: printf(BLANCO"La letra es la D del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la D del DNI %d \n\n",DNI); break;
 case 10: printf(BLANCO"La letra es la X del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la X del DNI %d \n\n",DNI); break;
 case 11: printf(BLANCO"La letra es la B del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la B del DNI %d \n\n",DNI); break;
 case 12: printf(BLANCO"La letra es la N del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la N del DNI %d \n\n",DNI); break;
 case 13: printf(BLANCO"La letra es la J del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la J del DNI %d \n\n",DNI); break;
 case 14: printf(BLANCO"La letra es la Z del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la Z del DNI %d \n\n",DNI); break;
 case 15: printf(BLANCO"La letra es la S del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la S del DNI %d \n\n",DNI); break;
 case 16: printf(BLANCO"La letra es la Q del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la Q del DNI %d \n\n",DNI); break;
 case 17: printf(BLANCO"La letra es la V del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la V del DNI %d \n\n",DNI); break;
 case 18: printf(BLANCO"La letra es la H del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la H del DNI %d \n\n",DNI); break;
 case 19: printf(BLANCO"La letra es la L del DNI %d \n\n"STAN"",DNI);
         fprintf(a,"La letra es la L del DNI %d \n\n",DNI); break;
 case 20: printf(BLANCO"La letra es la C del DNI %d \n\n"STAN"",DNI);
         fprintf(a,"La letra es la C del DNI %d \n\n",DNI); break; 
 case 21: printf(BLANCO"La letra es la K del DNI %d \n\n"STAN"",DNI);
         fprintf(a,"La letra es la K del DNI %d \n\n",DNI); break;
 case 22: printf(BLANCO"La letra es la E del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la E del DNI %d \n\n",DNI); break;
 case 23: printf(BLANCO"La letra es la T del DNI %d \n\n"STAN"",DNI); 
         fprintf(a,"La letra es la T del DNI %d \n\n",DNI); break;
     }
}
 
void nif_aleatorio() 
{

printf(STAN"\nCuantos numeros deseas generar : ");
scanf("%d",&NUM_ALEA);

for(kk=0;kk<=NUM_ALEA;kk++)
{
  DNI=1+(int) (100000000.0*rand()/(RAND_MAX+1.0));
  //  DNI= rand();
 CALCULO=DNI/NUM;
 CALCULO2=CALCULO*NUM;
 LETRA=DNI-CALCULO2;
 letra();
}
 
printf(BLANCO"He generado %d Numeros\n"STAN"",NUM_ALEA);
fprintf(a,"He generado %d Numeros a fea de %s a las %s \n",NUM_ALEA, __DATE__ , __TIME__);
salida();
}

void leo_dni()
{
printf("\n Dime el archivo que tengo leer : ");
 scanf("%s",&arch_dni);

if ((a=fopen(arch_dni,"r")) == NULL){
   printf("\n Error al intentar de abrir el fichero %s. \n",arch_dni);
   exit(-1); }  

fscanf(a,"%d",&DNI);
generar_nif();
fclose(a);
salida();
}

void salida()
{
 printf(AZUL"\n%s \n\n"STAN"",VERSION);
 exit(0);
}

void aborta()
{
printf ("\nHas pulsado CTRL-C\n");
printf(STAN"\n Se ha abortado el programa hay que joerse.\n");
exit(0);
}



        /* 7a69Soft - http://www.7a69ezine.8m.com */
