/*************-//| 7a69Soft - http://www.7a69ezine.8m.com |\\-***************
*                                                                           *
*  TILE: Generic Bouncer                                                    *
*  CODER: Doing - < jdoing@bigfoot.com >                                    *
*                                                                           *
*  TO COMPILE: gcc g_bnc.c -o g_bnc                                         *
*                                                                           *
*  NOTE: Betatester |^DeViL^|, thz man.                                     *
*                                                                           * 
****************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

void comunica(int, struct sockaddr_in *);
long resuelve(char *);

void main(int argc, char **argv)
{
  int fd, nfd, on = 1;
  struct sockaddr_in dir = { AF_INET, 0, INADDR_ANY };
  struct sockaddr_in serv = { AF_INET, 0 , 0};
  char host[128];
  char *passwd = NULL;
  char tmp[257];

  printf(" Generic bouncer - by Doing\n");
  
  if (argc < 4) {
    printf(" Uso:\n");
    printf("\t%s <puerto> <server> <puerto_server> [password]\n\n",argv[0]);
    exit(0);
  }

  if (argc > 4) {
        passwd = (char*) malloc(strlen(argv[4]) + 1);
        strcpy(passwd, argv[4]);
  }
  if ((fd = socket(AF_INET, SOCK_STREAM, 6)) < 0) {
    perror(" socket() ");
    exit(0);
  }

  setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));

  dir.sin_port = htons(atoi(argv[1]));
  if (bind(fd, (struct sockaddr_in*) &dir, sizeof(dir)) != 0) {
    perror(" bind() ");
    exit(0);
  }

  serv.sin_addr.s_addr = resuelve(argv[2]);
  serv.sin_port = htons(atoi(argv[3]));

  printf(" Bouncer instalado!\n");

  listen(fd, 5);
  if (fork()) exit(0);
  
  for (;;) {
    nfd = accept(fd, NULL, NULL);
    switch(fork()) {
    case 0:
      close(fd);
      if (passwd) {
        write(nfd, "Password: ", 10);
        memset(tmp, 0, 257);
        read(nfd, tmp, 256);
         
        if (strcmp(tmp, passwd)) {
                write(nfd,"Chico malo\n", 11);
                close(nfd);
                break;
        }
        }
      comunica(nfd, &serv);
      exit(0);
      break;
    default:
      close(nfd);
      if (fork()) exit(0);
      break;
    }
  }
}

void comunica(int fd, struct sockaddr_in *dir)
{
  int nfd = socket(AF_INET, SOCK_STREAM, 6);
  int fl;
  int leidos;
  char buffer[8192];

  if (nfd < 0) exit(0);

  if (connect(nfd, dir, sizeof(struct sockaddr_in)) < 0) exit(0);

  fl = fcntl(fd, F_GETFL);
  fcntl(fd, F_SETFL, fl | O_NONBLOCK);
  fl = fcntl(nfd, F_GETFL);
  fcntl(nfd, F_SETFL, fl | O_NONBLOCK);

  for (;;) {
    
    if ((leidos = read(nfd, buffer, 8192)) > 0) if (write(fd, buffer, leidos) < 0) exit(0);
    if (leidos == 0) exit(0);
    if (leidos == -1)
      if (errno != EAGAIN) exit(0);
    if ((leidos = read(fd, buffer, 8192)) > 0) if (write(nfd, buffer, leidos) < 0) exit(0);
    if (leidos == 0) exit(0);
    if (leidos == -1)
      if (errno != EAGAIN) exit(0);
  }
}

long resuelve(char *nom)
{
  long re;
  struct hostent *nm;
  re = inet_addr(nom);
  nm = gethostbyname(nom);
  if (re == -1) {
      if (nm != NULL) {
	bcopy(nm->h_addr,(char *)&re,nm->h_length);
	return re;
      }
      printf("\n error: gethostbyname(): %s\n\n",strerror(errno));
      exit(0);
  } 
  return re;
}
