/*************-//| 7a69Soft - http://www.7a69ezine.8m.com |\\-***************
*                                                                           *
*  TILE: fireIPS (Firewall Ipchains Pachanga Solutions)                     *
*  CODER: Trycky - <trycky_83@mixmail.com>                                  *
*                                                                           *
*  TO COMPILE: ./Compilar                                                   *
*                                                                           *
*  NOTE: Este programa crea un archivo que se carga al inicio de linux con  *
*        el fin de usar ipchains, una buena herramienta para el uso de un   *
*        firewall en linux. Antes que nada se debera compilar el nucleo con *
*        soporte firewall, leanse mi doc secure.txt por si no saben hacerlo *
*        y el que he hecho para este soft, firewall.txt                     *
*                                                                           *
*        Cosas que implementar: -Mirar si esta instalado el ipchains        *
*                               -Mejorar la creacion de los scripts         *
*                               -Leer configuraciones
*                                                                           *
****************************************************************************/

 
#include "firewall.h" // Librerias me gusta siempre meterlo todo en una solo.

WINDOW *titulo;

void comprueba();
void acerca_de();
void salir();
void new_conf();
void listar_info();
void genera_script();
void menu();
void aborta();
void scaneo_printf();
void scaneo_curses();
void digo_error();

char Ins_Script,ACCEPT_MAK[];
int host_yeah,hago_puertos=0;
int puerto_X,puerto_Y,puerto_XY=0; // 0 desactivao | 1 activao
int opcion,OPCION_1,puerto_no,puerto_num=0,cont,puerto_obj[25];
int fd;
int UDP_SI=0,ICMP_SI=0,TCP_SI=0,PUERTO_SI=0; // 0 desactivao | 1 activao
int scaneo_si=0;
char *QUERY_TCP="Desactivao",*QUERY_UDP="Desactivao",*QUERY_ICMP="Desactivao";
int no_error=0; // Esto chekea y cuando sucede algo muestra lo que se declare
int ERROR_NUM,r00t;

main ()
{
signal (SIGINT, aborta);
initscr();
start_color();
 init_pair(1, COLOR_WHITE, COLOR_BLACK); // Estandar 
 init_pair(2, COLOR_WHITE, COLOR_RED);
 init_pair(3, COLOR_BLUE, COLOR_RED);
 init_pair(4, COLOR_WHITE, COLOR_BLUE);
 init_pair(5, COLOR_RED, COLOR_BLACK);
 init_pair(6, COLOR_BLUE, COLOR_BLACK);
 init_pair(7, COLOR_GREEN, COLOR_BLACK);
CURSOR_NO();
menu();
salir();
}

void menu()
{

titulo=newwin(25,80,0,0);

wattrset(titulo, COLOR_PAIR(4));
mvwprintw(titulo,0,0,"-=( Bienvenido fireIPS a %s )=-                           ",VERSION);
wattrset(titulo, COLOR_PAIR(1));
mvwprintw(titulo,2,1,"1) Acerca de fireIPS.");
mvwprintw(titulo,3,1,"2) Configuracion de un archivo nuevo.");
mvwprintw(titulo,4,1,"3) Listar info del sistema.");
mvwprintw(titulo,5,1,"4) Salir.");
wattrset(titulo, COLOR_PAIR(4));
//mvwprintw(titulo,23,1,"Escoge tu opcion :                                                            ");
wrefresh(titulo);
wattrset(titulo, COLOR_PAIR(1));
endwin();
scanf("%i",&opcion);
 if (isalpha(opcion) != 0 ){
   no_error=1;
   aborta(); 
}

mvwprintw(titulo,15,1,"Escogiste la opcion [%i]",opcion);
switch(opcion){
 case 1: acerca_de(); break;
 case 2: new_conf(); 
 endwin();break;
 case 3: listar_info(); break;
 case 4: salir(); break; 
 default : mvprintw(titulo,16,1,"Escoge una opcion entre el 1 y 4.");
 break;
 wrefresh(titulo);
 }
endwin();
}

void acerca_de()
{
system("less fireIPS.txt");
return(0);
} 

void new_conf()
{

system("clear");

if (ICMP_SI==1){
QUERY_ICMP="Activado";
}
else 
QUERY_ICMP="Desactivado";

if (TCP_SI==1){
QUERY_TCP="Activado";
}
else 
QUERY_TCP="Desactivao";

if (UDP_SI==1){
QUERY_UDP="Activado";
}
else
QUERY_UDP="Desactivao";

titulo=newwin(25,80,0,0);
wattrset(titulo, COLOR_PAIR(4));
mvwprintw(titulo,0,0,"-=( Bienvenido fireIPS a %s )=-=( Escogiste la opcion [%i])=-",VERSION,opcion);
wattrset(titulo, COLOR_PAIR(1));
mvwprintw(titulo,2,1,"Que protocolos quieres denegar en tu maquina :");
mvwprintw(titulo,3,2,"1 )=- ICMP (%s). ",QUERY_ICMP);
mvwprintw(titulo,4,2,"2 )=- TCP (%s). ",QUERY_TCP);
mvwprintw(titulo,5,2,"3 )=- UDP (%s). ",QUERY_UDP);
mvwprintw(titulo,6,2,"4 )=- Puerto en concreto.");
mvwprintw(titulo,7,2,"5 )=- Meter rango de maquinas amistosas.");
mvwprintw(titulo,8,2,"6 )=- Generar el script.");
mvwprintw(titulo,9,2,"7 )=- Regresar al menu.");
mvwprintw(titulo,10,2,"8 )=- Hacer Scaneo de puertos.");
wrefresh(titulo);

scanf("%i",&OPCION_1);
 if (isalpha(OPCION_1) != 0 ){
   exit(0);
 }
mvwprintw(titulo,12,2,"\nEscogiste la opcion [%d]",OPCION_1);
 switch(OPCION_1)
   {
   case 1: 
 if(ICMP_SI==0) ICMP_SI=1; 
 else ICMP_SI=0;
 new_conf();
 break;
   case 2: 
 if(TCP_SI==0) TCP_SI=1; 
  else TCP_SI=0;
 new_conf();
 break;
   case 3: 
 if(UDP_SI==0) UDP_SI=1;
  else UDP_SI=0; 
 new_conf();  
 break;

 case 4: puerto_no=1 ;

titulo=newwin(25,80,0,0);
wattrset(titulo, COLOR_PAIR(4));
if(no_error==1) {
mvwprintw(titulo,0,0,"-=( Pues en algo la joiste %s )=-           ",ERROR_NUM);
}
else
mvwprintw(titulo,0,0,"-=( Bienvenido fireIPS a %s )=-=( Escogiste la opcion [%i])=-",VERSION,opcion);
wattrset(titulo, COLOR_PAIR(1));
mvwprintw(titulo,2,2,"1 )=-Agregar un puerto al bloqueo");
mvwprintw(titulo,3,2,"2 )=-Bloquear desde X puerto hasta Y puerto");
mvwprintw(titulo,4,2,"3 )=-Eliminar todas las entradas");
mvwprintw(titulo,5,2,"4 )=-Volver");
wrefresh(titulo);
   scanf("%d",&OPCION_1);
    switch(OPCION_1) {
     case 1 :
      mvwprintw(titulo,7,2,"Cuantos puertos quieres aadir :");   
      wrefresh(titulo); 
      scanf("%d",&puerto_num);
       for(cont=0;cont<puerto_num;cont++){ 
      mvwprintw(titulo,8,2,"Que puerto quieres bloquear (%d) : ",cont);
      wrefresh(titulo);  
      scanf("%i",&puerto_obj);
       }
       new_conf(); 
     break;
    case 2 :
      CURSOR_SI();
      mvwprintw(titulo,7,2,"Desde que puerto quieres bloquear :");
      wrefresh(titulo);
      scanf("%i",&puerto_X);
      mvwprintw(titulo,8,2,"Hasta el :");
      wrefresh(titulo);
      scanf("%i",&puerto_Y);
    if(puerto_X>=puerto_Y){
      mvwprintw(titulo,9,3,"No puedes asignar un puerto menor al del primero [ERROR]");
      wrefresh(titulo);
      sleep(1);
        new_conf();
      }
      mvwprintw(titulo,9,2,"De acuerdo..");
      wrefresh(titulo);
      puerto_XY=1;
      new_conf();
      break;
    case 3 :
      puerto_no=0;
      mvwprintw(titulo,7,2,"\nLimpieza completada");
      new_conf();
      break;
    case 4 :   
     menu(); 
     break;
     }
   case 5:
    mvwprintw(titulo,2,1,"Aadir una maquina a las permitidas.\n");
    scanf("%s",&ACCEPT_MAK);
    mvwprintw(titulo,3,1," %s Maquina aadida",ACCEPT_MAK);
    host_yeah++;
    hago_puertos=1;
    wrefresh(titulo);  
    new_conf();
    break; 
  case 6: genera_script();
    break;
  case 7: menu();
    break;
  case 8 : delwin(titulo);
  endwin(); 
  scaneo_curses();
  getchar();
  new_conf();  
   break;
   default: 
     no_error==1;
     new_conf();
   break; 
  }
endwin();
}

/*****************************************************/
/* Esta funcion es la encargada de generar el script */
/*****************************************************/

void genera_script()
{
if ((fd=fopen(ARCHIVO,"w+")) == NULL){
   mvprintw(titulo,12,1,"Error al crear el fichero %s.",ARCHIVO);
   salir();
}

fprintf(fd,"#Script de configuracion del ipchains , %s .",VERSION);
fprintf(fd,"\n#Generado en %s a las %s",__DATE__ , __TIME__);
fprintf(fd,"\n echo -n 'Deseas instalar el firewall [S/N]:'
 read opcion
 case $opcion in");
fprintf(fd,"\nS) echo -ne 'Instalando el firewall ...'\n");
fprintf(fd,"\n# Esto limpia todas las reglas");
fprintf(fd,"\n ipchains -F input");
fprintf(fd,"\n ipchains -F output");
fprintf(fd,"\n ipchains -F forward");
if(hago_puertos==1){
  for(cont=1;host_yeah==cont;cont++){
fprintf(fd,"\n ipchains -A input -s %s -j ACCEPT ",ACCEPT_MAK);
 }
cont==0;
}
fprintf(fd,"\n#Ahora biene los protocolos que deja y a los que no.");
if(ICMP_SI==1){
 fprintf(fd,"\n exec ipchains -A input -p icmp -j DENY");
}
if(UDP_SI==1){
 fprintf(fd,"\n exec ipchains -A input -p udp -j DENY");
}
if(TCP_SI==1){
 fprintf(fd,"\n exec ipchains -A input -p tcp -j DENY");
}
fprintf(fd,"\n#Ahora biene los puerto que deja y a los que no deja.");
if(puerto_no==1){
  for(cont=0;cont<puerto_num;cont++){
fprintf(fd,"\n exec ipchains -A input -p tcp -j deny 0.0.0.0 %i ",puerto_obj[cont]);
  }
}
if(puerto_XY==1){
fprintf(fd,"\n exec ipchains -A input -p tcp -j deny 0.0.0.0 %d/%d",puerto_X,puerto_Y);
}
fprintf(fd,"\n echo 'Instalacion terminada' ;;");
fprintf(fd,"\n *) echo 'Firewall no instalado';;"  "  esac \n");
fprintf(fd,"\n#Fin del Script de configuracion del IPchains\n.");

mvwprintw(titulo,12,1,"Script creado yeah! . Con el nombre de %s ",ARCHIVO);
wrefresh(titulo);

fclose(fd);

mvwprintw(titulo,14,1,"Deseas ejecutar el script de instalacion ahora [S/N] ");
wrefresh(titulo);
scanf("%s",&Ins_Script);
 switch(Ins_Script){
 case 's':
 case 'S': 
   if(getuid() != 0 ){ 
 mvwprintw(titulo,15,1,"Solo el root puede ejecutar el script de instalacion");
 wrefresh(titulo);
 salir(); }
 else
 mvwprintw(titulo,15,1,"Beta version");  
 salir();
 break;
 default: salir(); break;
 wrefresh(titulo);
 }
exit(0);
}

void listar_info()
{
endwin();
CURSOR_SI();
printf("\n No implementado todavia del todo.\n");
system("uname -mrsp");
scaneo_printf();
printf("\n %s \n",VERSION);
exit(0);
}

/****************************************/
/* La funcion de la salida del programa */ 
/****************************************/
void salir()
{
endwin();
CURSOR_SI();
if(no_error==1){
printf("\nPos eso un error");
}
printf("\n %s \n",VERSION);
exit(0);
}

/*********************************************************************/
/* Recive la llamada de signal y la manda para aca y de aqui salimos */
/*********************************************************************/
void aborta()
{
delwin(titulo);
endwin();
CURSOR_SI();
printf("\n Has abortado el programa con pid %d.", getpid());
printf("\n %s \n",VERSION);
exit(0);
}

/* Comprueba si esta instalado el ipchains */
void comprueba()
{
endwin();
printf("\nNo implementado todavia.");
exit(0);
}

/*********************************************************/
/* Esta opcion le da un valor pa decir que error muestra */
/*********************************************************/
void digo_error()
{
printf("eoeoe");
}


           /* 7a69Soft - http://www.7a69ezine.8m.com */
